﻿Imports System.Math
Imports System.Diagnostics
Imports System.Management
Imports System.Xml
Imports System.IO
Imports System.Runtime.Serialization
Imports System.Runtime.Serialization.Formatters.Binary
Imports System.Text.RegularExpressions

Public Class Class_many
    Dim puth As String 'Путь к запущенному приложению 
    Dim url As String 'Файл на сервере с котировкой
    Dim Many_file As String 'Файл на клиенте, куда положить котировку валюты
    Private Declare Function URLDownloadToFile Lib "urlmon" Alias "URLDownloadToFileA" (ByVal pCaller As Integer, ByVal szURL As String, ByVal szFileName As String, ByVal dwReserved As Integer, ByVal lpfnCB As Integer) As Integer
    Public Event ErrorDownload(ByVal FromPathName As String, ByVal ToPathName As String)
    Public Event DownloadComplete(ByVal FromPathName As String, ByVal ToPathName As String)

    Public Sub New()
        'Полный путь к библиотеке
        Dim sFullPuth As String = System.Reflection.Assembly.GetExecutingAssembly().Location
        puth = Left(sFullPuth, sFullPuth.LastIndexOf("\"))
        Many_file = puth & "\Temp\many" & ".html"
    End Sub

    Public Function DownloadFile(ByVal FromPathName As String, ByVal ToPathName As String, ByVal idTextbox As Integer)

        If URLDownloadToFile(0, FromPathName, ToPathName, 0, 0) = 0 Then
            DownloadFile = True
            RaiseEvent DownloadComplete(FromPathName, ToPathName)
        Else
            DownloadFile = False
            RaiseEvent ErrorDownload(FromPathName, ToPathName)
        End If

    End Function

    Public Function Get_many() As String
        Dim Result As String = ""
        Dim datas = Microsoft.VisualBasic.Left(Date.Today.ToString, 10)
        url = "http://bank.gov.ua/Fin_ryn/OF_KURS/Currency/FindByDate.aspx?__EVENTARGUMENT=&__EVENTTARGET=&Text1=" & datas
        Call DownloadFile(url, Many_file, 3)
        'Расшифровать полученный файл

        Try
            Dim MANY As Object = File.ReadAllText(Many_file)

            Dim zPos As Integer, zEnd As Integer
            Result = String.Empty

            zPos = MANY.IndexOf("<td>Офіційний курс</td>")
            zEnd = MANY.IndexOf("</table>", zPos)
            If zPos <> -1 AndAlso zEnd <> -1 Then
                Result = MANY.Substring(zPos, zEnd - zPos)
            End If
            Result = Result.Replace("<td>Офіційний курс</td>", "")
            Result = Result.Replace("</tr><tr class=" & Chr(34) & "G1" & Chr(34) & " align=" & Chr(34) & "Center" & Chr(34) & " valign=" & Chr(34) & "Middle" & Chr(34) & " style=" & Chr(34) & "border-style:Dotted;height:22px;" & Chr(34) & ">", "")
            Result = Result.Replace("</tr><tr class=" & Chr(34) & "w1" & Chr(34) & " align=" & Chr(34) & "Center" & Chr(34) & " valign=" & Chr(34) & "Middle" & Chr(34) & " style=" & Chr(34) & "border-style:Dotted;height:22px;" & Chr(34) & ">", "")
            Result = Result.Replace("<td align=" & Chr(34) & "Center" & Chr(34) & " style=" & Chr(34) & "width:15%;" & Chr(34) & ">", "")
            Result = Result.Replace("<td align=" & Chr(34) & "Center" & Chr(34) & ">", "")
            Result = Result.Replace("</td>", " ")
            Result = Result.Replace("<td align=" & Chr(34) & "Left" & Chr(34) & " style=" & Chr(34) & "width:40%;" & Chr(34) & ">", "")
            Result = Result.Replace("<td align=" & Chr(34) & "Right" & Chr(34) & " style=" & Chr(34) & "width:20%;" & Chr(34) & ">", "")
            Result = Result.Replace("<td align=" & Chr(34) & "Left" & Chr(34) & ">", "")
            Result = Result.Replace("<td align=" & Chr(34) & "Right" & Chr(34) & ">", "")
            Result = Result.Replace("</tr>", "")
            Result = Result.Replace(Chr(9), "")
            Dim a() = Split(Result, Chr(10))
            Result = "Середній курс гривні до іноземних валют на " & datas & " становить: " & Chr(10)
            For i = 0 To a.Length - 1
                If a(i) <> Chr(13) Then
                    If a(i).Length > 7 Then
                        a(i) = Strings.Right(a(i), a(i).Length - 7)
                        a(i) = Strings.Left(a(i), a(i).Length - 1) & "грн.; "
                        Result = Result & a(i)
                    End If
                End If
            Next
            Result = Result & " Національний банк України."

        Catch ex As Exception
            Result = "Ошибка при расшифровке файла."
        Finally
            'Удалить полученный файл
            If File.Exists(Many_file) = True Then File.Delete(Many_file)
            Get_many = Result
        End Try

    End Function

End Class